<script lang="ts">
  import type { ConstantBody, JSONValue } from '$lib';
  import { focusElement } from '$lib';
  import Dropdown from '$lib/Dropdown.svelte';
  import ObjectElement from '$lib/ObjectElement.svelte';
  import DeleteButton from '$lib/DeleteButton.svelte';

  // Define props
  export let value: ConstantBody;

  let valueType: string = typeof value;
  switch (valueType) {
    case 'string':
    case 'boolean':
    case 'number': {
      break; // Nothing to be done
    }

    default: {
      // Note: the other types are all derived as 'object', so we have to derive them with more logic
      if (value === null) {
        valueType = 'null';
      } else if (isListValue(value)) {
        valueType = 'list';
      } else if (isObjectValue(value)) {
        valueType = 'object';
      } else {
        valueType = 'null'; // Fallback value
      }
    }
  }

  function isListValue(val: JSONValue): val is JSONValue[] {
    return (val as JSONValue[]) !== undefined && Array.isArray(val);
  }

  function isObjectValue(val: JSONValue): val is { [key: string]: JSONValue } {
    return (val as { [key: string]: JSONValue }) !== undefined && val !== null;
  }

  // If the value type changes, reset/convert the value
  let oldValueType = valueType;

  $: handleValueTypeChange(valueType);

  function handleValueTypeChange(newValueType: string) {
    // Return if not changed
    if (newValueType === oldValueType) {
      return;
    }
    oldValueType = newValueType;

    switch (newValueType) {
      case 'string': {
        value = '';
        break;
      }

      case 'boolean': {
        value = true;
        break;
      }

      case 'number': {
        value = 0;
        break;
      }

      case 'list': {
        value = [null];
        break;
      }

      case 'object': {
        value = { key: null };
        break;
      }

      case 'null': {
        value = null;
        break;
      }
    }
  }

  function deleteListItem(i: number): undefined {
    if (isListValue(value)) {
      value.splice(i, 1);
      value = value; // Re-render the elements
    }
  }
</script>

<div>
  Constante van type <Dropdown
    bind:value={valueType}
    options={[
      { value: 'string', label: 'String (tekst)' },
      { value: 'boolean', label: 'Boolean (ja / nee)' },
      { value: 'number', label: 'Getal' },
      { value: 'list', label: 'Lijst' },
      { value: 'object', label: 'Object' },
      { value: 'null', label: 'Null (leeg)' },
    ]}
  />
  {#if valueType !== 'null'}met waarde{/if}
  {#if valueType === 'string'}
    <input
      bind:value
      use:focusElement
      type="text"
      class="inline-block w-80 rounded-lg border border-gray-300 p-2.5 text-gray-800 placeholder:text-gray-400 focus:border-indigo-500 focus:outline-none focus:ring-1 focus:ring-indigo-500"
      placeholder="Waarde van de constante"
      autocomplete="off"
    />
  {:else if valueType === 'boolean'}
    <label class="ml-2 mr-3 inline-flex items-center align-[-0.125rem]">
      <input
        class="form-radio mr-2 border-gray-300 bg-white text-indigo-600 focus:ring-indigo-500"
        type="radio"
        bind:group={value}
        value={true}
      />
      Ja
    </label>
    <label class="inline-flex items-center align-[-0.125rem]">
      <input
        class="form-radio mr-2 border-gray-300 bg-white text-indigo-600 focus:ring-indigo-500"
        type="radio"
        bind:group={value}
        value={false}
      />
      Nee
    </label>
  {:else if valueType === 'number'}
    <!-- Note: cannot be combined with the 'string' case because of the bind:value attribute -->
    <input
      bind:value
      use:focusElement
      type="number"
      class="inline-block w-80 rounded-lg border border-gray-300 p-2.5 text-gray-800 placeholder:text-gray-400 focus:border-indigo-500 focus:outline-none focus:ring-1 focus:ring-indigo-500"
      placeholder="Waarde van de constante"
      autocomplete="off"
    />
  {:else if valueType === 'list'}
    {#if isListValue(value)}
      {#each value as _, i (i)}
        <div class="mt-3 rounded-md border border-slate-200 px-4 py-2">
          <DeleteButton on:click={deleteListItem(i)} extraClasses="mt-0" />
          <svelte:self bind:value={value[i]} />
        </div>
      {:else}
        <p class="text-gray-500 mt-2">(Nog geen elementen)</p>
      {/each}

      <p class="mt-4">
        <button
          on:click={() => {
            if (isListValue(value)) {
              value = [...value, null];
            }
          }}
          class="inline-flex items-center rounded-lg border border-indigo-300 bg-indigo-50 px-2.5 py-1.5 text-sm font-medium text-indigo-800 shadow-sm hover:border-indigo-400 hover:bg-indigo-100 hover:text-indigo-950 focus:outline-none focus:ring-4 focus:ring-indigo-100"
          type="button"
        >
          <svg class="-ml-0.5 mr-2 h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24">
            <path
              fill="none"
              stroke="currentColor"
              stroke-linecap="round"
              stroke-linejoin="round"
              stroke-width="2"
              d="M12 5v14m-7-7h14"
            />
          </svg>
          Voeg een element toe
        </button>
      </p>
    {/if}
  {:else if valueType === 'object'}
    {#if isObjectValue(value)}
      <ObjectElement bind:value />
    {/if}
  {/if}
</div>
